package org.hardknockjava.example02;

import java.util.Comparator;
import java.util.Set;
import java.util.TreeSet;

public class LostItem  {
    private static Comparator<LostItem> theComparator  = new Comparator<LostItem>()
    {
        @Override
        public int compare(LostItem o1, LostItem o2) {
            return o1.getTheKey().compareTo(o2.getTheKey());
        }
    };

    private static Set<LostItem> theSet = new TreeSet<LostItem>(theComparator);

    private Integer theKey = 0;
    private String theString = "";

    public static void main(String[] args) {
        // Add LostItems to the Set.
        LostItem theFirstItem = new LostItem(1, "the first one");
        LostItem theSecondItem = new LostItem(2, "the second one");
        LostItem theThirdItem = new LostItem(3, "the third one");
        LostItem theFourthItem = new LostItem(4, "the fourth one");
        LostItem theFifthItem = new LostItem(5, "the fifth one");
        LostItem theSixthItem = new LostItem(6, "the sixth one");

        theSet.add(theFirstItem);
        theSet.add(theSecondItem);
        theSet.add(theThirdItem);
        theSet.add(theFourthItem);
        theSet.add(theFifthItem);
        theSet.add(theSixthItem);
        
        report("Original Set", theThirdItem, theSet);

        theThirdItem.setTheKey(200);
        report("Ruined Set", theThirdItem, theSet);

        theSet.add(theThirdItem);
        report("After adding theThirdItem again", theThirdItem, theSet);
    }

    public LostItem(Integer theKey, String theString) {
        super();
        this.theKey = theKey;
        this.theString = theString;
    }

    private static void report(String caption, LostItem theSearchItem, Set<LostItem> theSet) {
        // See if the LostItem provided can be located.
        boolean itemFound = theSet.contains(theSearchItem);
        int theHash = theSearchItem.hashCode();
        System.out.println(caption + "\n" //
                + "Current values for theSearchItem: theKey=" //
                + theSearchItem.getTheKey() + " hashCode = " + theHash //
                + "  theString=" + theSearchItem.getTheString());
        System.out.println("  The key " //
                + (itemFound ? "WAS" : "WAS NOT") //
                + " found in the Set");
        ;

        // Compare theKey to each element in the Set to see
        // if they are, in fact, equal.
        System.out.println("Items in the Set");
        for (LostItem theItem : theSet) {
            boolean equalsTheSearchItem = theItem.equals(theSearchItem);
            System.out.println("  theKey=" + theItem.getTheKey() //
                    + "  theString=" + theItem.getTheString() //
                    + " hashCode=" + theItem.hashCode() //
                    + " equalsTheSearchItem=" + equalsTheSearchItem);
        }
        System.out.println();
    }

    public Integer getTheKey() {
        return theKey;
    }

    public void setTheKey(Integer theKey) {
        this.theKey = theKey;
    }

    public String getTheString() {
        return theString;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((theKey == null) ? 0 : theKey.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (!(obj instanceof LostItem))
            return false;
        LostItem other = (LostItem) obj;
        if (theKey == null) {
            if (other.theKey != null)
                return false;
        } else if (!theKey.equals(other.theKey))
            return false;
        return true;
    }

}
